# kube-green

## IMPORTANT

This Helm Chart is archived. Please use the officiel Helm Chart [here](https://github.com/kube-green/kube-green/tree/main/charts/kube-green)


kube-green is a simple k8s addon that automatically shuts down (some of) your resources when you don't need them.

![Version: 0.0.20](https://img.shields.io/badge/Version-0.0.20-informational?style=flat-square) ![Type: application](https://img.shields.io/badge/Type-application-informational?style=flat-square) ![AppVersion: 0.5.2](https://img.shields.io/badge/AppVersion-0.5.2-informational?style=flat-square)

## Maintainers

| Name | Email | Url |
| ---- | ------ | --- |
| Additi | <dsi@of2m.fr> | <https://gitlab.com/additi/external/kube-green> |

## Installing the Chart

### Prerequisite
kube-green support all Kubernetes cluster versions >= 1.19 <= 1.28 and OpenShift Container Platform v4.

Supported architectures are: amd64, arm64.

To successfully install kube-green, in the cluster must be installed a cert-manager. If it is not already installed installed, [click here](https://cert-manager.io/docs/installation/).

### Install
To install the chart with the release name `my-release`:

```console
$ helm repo add kube-green https://kube-green.additi.fr/
$ helm install my-release kube-green/kube-green
```

## CRD Examples

Pods running during working hours with Europe/Rome timezone, suspend CronJobs and exclude a deployment named `api-gateway`:

```yaml
apiVersion: kube-green.com/v1alpha1
kind: SleepInfo
metadata:
  name: working-hours
spec:
  weekdays: "1-5"
  sleepAt: "20:00"
  wakeUpAt: "08:00"
  timeZone: "Europe/Rome"
  suspendCronJobs: true
  excludeRef:
    - apiVersion: "apps/v1"
      kind:       Deployment
      name:       api-gateway
```

Pods sleep every night without restore:

```yaml
apiVersion: kube-green.com/v1alpha1
kind: SleepInfo
metadata:
  name: working-hours-no-wakeup
spec:
  sleepAt: "20:00"
  timeZone: Europe/Rome
  weekdays: "*"
```

To see other examples, go to [kube-green docs](https://kube-green.dev/docs/configuration/#examples).

## Source Code

* <https://gitlab.com/additi/external/kube-green>
* <https://kube-green.dev/>
* <https://github.com/kube-green/kube-green>

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| affinity | object | `{}` | Affinity settings for pod assignment |
| commonLabels | object | `{}` |  |
| fullnameOverride | string | `""` | String to fully override `"kube-green.fullname"` |
| kubeGreen.image.pullPolicy | string | `"IfNotPresent"` | kube-green image pull policy |
| kubeGreen.image.repository | string | `"docker.io/kubegreen/kube-green"` | kube-green image repository |
| kubeGreen.image.tag | string | `"0.5.2@sha256:5ede69b66ee7b23edf3d083fd23c6c740496769ae87eeff31363e80c0409f1d6"` | Overrides the kube-green image tag |
| kubeGreen.resources | object | `{"limits":{"cpu":"400m","memory":"400Mi"},"requests":{"cpu":"100m","memory":"50Mi"}}` | Resource limits and requests for kube-green pods. |
| kubeRbacProxy.image.pullPolicy | string | `"IfNotPresent"` | kube-rbac-proxy image pull policy |
| kubeRbacProxy.image.repository | string | `"gcr.io/kubebuilder/kube-rbac-proxy"` | kube-rbac-proxy image repository |
| kubeRbacProxy.image.tag | string | `"v0.16.0@sha256:771a9a173e033a3ad8b46f5c00a7036eaa88c8d8d1fbd89217325168998113ea"` | Overrides the kube-rbac-proxy image tag |
| kubeRbacProxy.resources | object | `{"limits":{"cpu":"500m","memory":"128Mi"},"requests":{"cpu":"5m","memory":"64Mi"}}` | Resource limits and requests for kube-rbac-proxy pods. |
| nameOverride | string | `""` | Provide a name in place of `kube-green` |
| nodeSelector | object | `{}` | Node labels for pod assignment |
| podSecurityContext | object | `{"runAsNonRoot":true,"seccompProfile":{"type":"RuntimeDefault"}}` | pod-level security context |
| priorityClassName | string | `""` | Priority class name to use for pods |
| replicaCount | int | `1` | Replica count for deployment |
| securityContext | object | `{"allowPrivilegeEscalation":false,"capabilities":{"drop":["ALL"]}}` | container-level security context |
| tolerations | list | `[]` | Toleration labels for pod assignment |
| topologySpreadConstraints | list | `[]` | Topology spread constraints for pod assignment |
| webhook | object | `{"enabled":true}` | Enable validation webhook |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.14.2](https://github.com/norwoodj/helm-docs/releases/v1.14.2)

## Upgrades

### 0.0.12 (Breaking Changes)

Change values for ressources and images

Before:
```yaml
image:
  kubeGreen:
    # -- kube-green image repository
    repository: docker.io/kubegreen/kube-green
    # -- kube-green image pull policy
    pullPolicy: IfNotPresent
    # -- Overrides the kube-green image tag
    tag: "0.5.2"
  kubeRbacProxy:
    # -- kube-rbac-proxy image repository
    repository: gcr.io/kubebuilder/kube-rbac-proxy
    # -- kube-rbac-proxy image pull policy
    pullPolicy: IfNotPresent
    # -- Overrides the kube-rbac-proxy image tag
    tag: "v0.15.0"

resources:
  # -- Resource limits and requests for kube-green pods.
  kubeGreen:
    limits:
      cpu: 400m
      memory: 400Mi
    requests:
      cpu: 100m
      memory: 50Mi
  # -- Resource limits and requests for kube-rbac-proxy pods.
  kubeRbacProxy:
    limits:
      cpu: 500m
      memory: 128Mi
    requests:
      cpu: 5m
      memory: 64Mi
```

Now:
```yaml
kubeGreen:
  image:
    # -- kube-green image repository
    repository: docker.io/kubegreen/kube-green
    # -- kube-green image pull policy
    pullPolicy: IfNotPresent
    # -- Overrides the kube-green image tag
    tag: "0.5.2"
  # -- Resource limits and requests for kube-green pods.
  resources:
    limits:
      cpu: 400m
      memory: 400Mi
    requests:
      cpu: 100m
      memory: 50Mi
 
kubeRbacProxy:
  image:
    # -- kube-rbac-proxy image repository
    repository: gcr.io/kubebuilder/kube-rbac-proxy
    # -- kube-rbac-proxy image pull policy
    pullPolicy: IfNotPresent
    # -- Overrides the kube-rbac-proxy image tag
    tag: "v0.15.0"
  # -- Resource limits and requests for kube-rbac-proxy pods.
  resources:
    limits:
      cpu: 500m
      memory: 128Mi
    requests:
      cpu: 5m
      memory: 64Mi
```